###
# mp3.tcl 2 - 7.20.98 - pawt
#
# allows you to play mp3's from xircon
# also has many different features (keeps history, various ways of listing, ..)
# note: you must have an mp3 player (kjofol (very good), winplay3, winamp, ..)
#
# if you find a bug or have a suggestion, tell me:
# fire@digitalpla.net or pawt on efnet.
#
## commands
# [regular ]     (req)   (opt)              (desc)
# help     : mp3 -h
# play     : mp3 [path/wildcard]            (none for random)
# setup    : mp3 -sdpcv  [dir/path]         (setup  : dir : player : continuous : version check)
# message  : mp3 -m      [add/del/list]     (restrict windows: add : delete : list : no parms toggles msg)
# format   : mp3 -f      [format chars]     (no chars for help)
# list     : mp3 -l[shf] [wild/dir]         (size : horizontal : full)
# ansi     : mp3 -a
# update   : mp3 -u                         (checks if there's a newer version)
#
# [playlist]
# help     : pl -h
# lists    : pl -scif    [file]             (status : create new : load old : list)
# manage   : pl -adl     [file]             (add mp3 ('current' adds current) : delete mp3 : list)
# play     : pl -pngr    [number]           (previous : next : go to : random)
# toggle   : pl -t[os]                      (status : shuffle)
#
# [hotkeys ]
# random   : ctrl+m
# specific : ctrl+alt+m
#
## greets
# greets to everyone I hang with on efnet
# 
# the greatest thanks goes to nicole, for being there when I need her,
# and being the greatest girl I've ever known.  Someday, I'm gonna
# marry her =]
# I LOVE YOU NICOLE!@!
#
# thanks to dianep for being a good friend of mine, and also for
# sticking this on the script page
#
# thanks to all you guys that helped me find bugs and gave me suggestions,
# it's appreciated..
#
# also, this script wouldn't work right if it weren't for my friend antiloop.
# he gave me the [bitrate] proc, which helped me out a lot. thanks anti..
#
# big thanks goes out to logicx for suggesting 1395834[..] things and
# reporting (almost) all the bugs. a ton of ideas for this came from him,
# and I appreciate it a lot.  thanks logicx..
#
## stuff to come
# from logicx
#  -add current song to playlist           [x] /pl -a current
#  -restricting /mp3 -m to certain windows [x] /mp3 -m [add/del/list] [window/#]
#  -toggle version check on-load on/off    [x] /mp3 -v
#  -directory in format                    [x] %f[df]
#  -make -l support subdirs                [x] /mp3 -l[shf] [dir]
#
# my own ideas
#  -mp3 search (use various engines?)       [ ]
#
## other crap
# the lengths are figured with a mathematical equation and a header-read to figure the
# bitrate. they aren't always perfectly right, but fairly close. tell me if you have a
# better way to find them, or if you find problems with certain songs.
#
# the [wildcard] in -l is just a regular pattern match. like *asdf*
#
# version info and extended help is in mp3.txt.
###

## procs
proc c1 {} { return 15 }
proc c2 {} { return 14 }
proc c3 {} { return 16 }
proc bul {} { return [c2][c1][c3][c1] }
proc str {rep txt} { if {[isnum $rep]} { for {set i 0; set temp ""} {$i < $rep} {incr i 1} { append temp $txt }; return $temp } }
proc randmp3 {} {
  if {![llength [findmp3 *]]} { return ""
  } elseif {[llength [findmp3 *]] == 1} { return [findmp3 *]
  } else { return [lindex [findmp3 *] [random 0 [expr [llength [findmp3 *]] - 1]]] }
}
proc right {count string} { return [string range [join $string] [expr [string length $string] - $count] end]  }
proc left {count string} { return [string range [join $string] 0 [expr [string length $string] - [expr [string length $string] - $count + 1]]] }
proc size {x y} {
  if {[file exists $x]} {
    set fs [file size $x]
    switch -- [string tolower $y] {
      b { return ${fs}b }
      k { return [string trimright [string trimright [format %0.1f [expr $fs / 1024.0]] 0] .]k }
      mb { return [format %0.1f [expr $fs / (1024.0 * 1024.0)]]mb }
    }
  } elseif {[isnum $x]} {
    switch -- [string tolower $y] {
      b { return ${x}b }
      k { return [string trimright [string trimright [format %0.1f [expr $x / 1024.0]] 0] .]k }
      mb { return [format %0.1f [expr $x / (1024.0 * 1024.0)]]mb }
    }
  }
}
proc align {x num} {
  set text [stripall $x]
  if {$num < [string length $text]} {
    return [string range $text 0 [expr $num - 1]]
  } else {
    set temp [expr $num - [string length $text]]
    for {set i 0; set sp ""} {$i < $temp} {incr i 1} { append sp " " }
    return $x$sp
  }
}
proc ralign {x num} {
  set text [stripall $x]
  if {$num < [string length $text]} {
    return [string range $text 0 [expr $num - 1]]
  } else {
    set temp [expr $num - [string length $text]]
    for {set i 0; set sp ""} {$i < $temp} {incr i 1} { append sp " " }
    return $sp$x
  }
}
proc stripall {args} {
  regsub -all -- "\[0-9\]\[0-9\],\[0-9\]\[0-9\]" $args "" args
  regsub -all -- "\[0-9\],\[0-9\]\[0-9\]" $args "" args
  regsub -all -- "\[0-9\]\[0-9\],\[0-9\]" $args "" args
  regsub -all -- "\[0-9\],\[0-9\]" $args "" args
  regsub -all -- "\[0-9\]\[0-9\]" $args "" args
  regsub -all -- "\[0-9\]" $args "" args
  regsub -all -- "" $args "" args
  regsub -all -- "" $args "" args
  regsub -all -- "" $args "" args
  regsub -all -- "" $args "" args
  regsub -all -- "" $args "" args
  return [join $args]
}
proc isnum {x} { regsub -all -- "\[0-9\]" $x "" x; if {[string length $x]} { return 0 } else { return 1 } }
proc minsec {secs} {
  if {[string match *:* $secs]} {
    set min [lindex [split $secs :] 0]
    set sec [string trimleft [lindex [split $secs :] 1] 0]
    if {$sec == ""} { set sec 0 }
    return [expr ($min *60) + $sec]
  } else {
    if {![string match *.* $secs]} { set secs $secs.0 }
    set secs [format %0.0f $secs]
    set sec [expr $secs % 60]
    if {[string length $sec] < 2} { set sec 0$sec }
    return [expr $secs /60]:$sec
  }
}
proc mp3len {lenfile} {
  if {![file exists $lenfile]} {
    if {[file exists [get_cookie setup(dir)]/$lenfile]} { set lenfile [get_cookie setup(dir)]/$lenfile } else { return }
  }
  if {[bitrate $lenfile] == 128} { return [minsec [expr [file size $lenfile] / 16032]]
  } elseif {[bitrate $lenfile] == 112} { return [minsec [expr [file size $lenfile] / 14034]]
  } elseif {[bitrate $lenfile] == 192} { return [minsec [expr [file size $lenfile] / 24034]]
  } else { return 0:00 }
}
proc bitrate {bitfile} {
  if {![file exists $bitfile]} {
    if {[findmp3 $bitfile] != ""} { set bitfile [findmp3 $bitfile] } elseif {[file exists [get_cookie setup(dir)]/$bitfile]} { set bitfile [get_cookie setup(dir)]/$bitfile } else { return }
  }
  set bitrates { "0" "8" "16" "24" "32" "40" "48" "56" "64" "80" "96" "112" "128" "144" "160" "176" "192" "224" "240" "256" }
  regsub -all // $bitfile / bitfile
  set mp3var [open $bitfile]
  gets $mp3var mp3line
  close $mp3var
  set len [string length [join $mp3line]]
  scan [string index [join $$mp3line] 3] %c char
  set char "[string range [expr $char-16] 0 1]"
  if { $char < 20 } { return [lindex $bitrates $char] } else { return 112 }
}
proc duration {x} {
  if {!$x} { return 0s }
  set s [expr [expr $x % 60] % 60]; set m [expr [expr $x / 60] % 60]
  set h [expr [expr $x / 3600] % 24]; set d [expr [expr $x / 86400] % 7]
  set w [expr [expr $x / 604800] % 52]; set y [expr [expr $x / 31449600] % 10]
  set de [expr [expr $x / 314496000] % 10]; set x ""
  if {$de} { append x ${de}de }; if {$y} { append x ${y}y }
  if {$w} { append x ${w}w }; if {$d} { append x ${d}d }
  if {$h} { append x ${h}h }; if {$m} { append x ${m}m }
  if {$s} { append x ${s}s }; return $x
}
proc mduration {x} {
  set x [duration $x]
  if {[right 1 $x] == "s"} { return [string trimright $x s]
  } else { return "$x0" }
}
proc msformat {x} {
  if {[string length $x] == 3} { set x 0$x
  } elseif {[string length $x] == 2} { set x 00$x
  } elseif {[string length $x] == 1} { set x 000$x }
  set length [expr [string length $x] - 3]
  set sec [left $length $x]
  set msec [right 3 $x]
  if {$sec == ""} { set sec 0 }
  set x [mduration $sec].${msec}s
  return [string trim $x]
}
proc mp3_format {file size} {
  set fmat [get_cookie setup(format)]
  regsub -all %ff $fmat $file fmat
  regsub -all [get_cookie setup(dir)] $file "" tmp
  regsub -all %fd $fmat $tmp fmat
  regsub -all %f $fmat [file tail $file] fmat
  regsub -all %sb $fmat [size $size b] fmat
  regsub -all %sk $fmat [size $size k] fmat
  regsub -all %smb $fmat [size $size mb] fmat
  regsub -all %s $fmat [size $size b] fmat
  regsub -all %v $fmat [get_cookie setup(ver)] fmat
  regsub -all %ls $fmat [minsec [mp3len $file]] fmat
  regsub -all %l $fmat [mp3len $file] fmat
  regsub -all %f $fmat {\&} fmat
  return $fmat
}
proc findmp3 {wc} {
  if {[file dirname $wc] == "."} { set dir [string trimright [get_cookie setup(dir)] /] } else { set dir [file dirname $wc] }
  set subdirs [glob -nocomplain $dir/*/]
  set matches ""
  set match [string tolower [file tail $wc]]
  foreach c $subdirs {
    if {[llength [glob -nocomplain $c/*.mp3]]} {
      foreach d [glob -nocomplain $c/*.mp3] {
        if {[string match $match [string tolower [file tail $d]]] && ![file isdirectory $d] && [file ext [string tolower [file tail $d]]] == ".mp3"} { lappend matches $d }
      }
    }
  }
  foreach c [glob -nocomplain $dir/$match] {
    if {[string match $match [string tolower [file tail $c]]] && ![file isdirectory $c] && [file ext [string tolower [file tail $c]]] == ".mp3"} { lappend matches $c }
  }
  return $matches
}
proc totplay {file} {
  set songs 0; set x [open $file]
  while {[gets $x tmp] > -1 && [join $tmp] != ""} { incr songs 1 }
  close $x; return $songs
}
proc curplay {} {
  global pl
  if {$pl(current)} { return [lindex [allplay] [expr $pl(current) -1]] }
}
proc allplay {} {
  global pl; set tmp ""; set x [open $pl(file)]
  while {[gets $x line] > -1} { lappend tmp $line }
  close $x
  return $tmp
}
proc songnum {num} {
  global pl; set i 0; set x [open $pl(file)]
  while {[gets $x line] > -1} { incr i 1; if {$i == $num} { close $x; return $line } }
  close $x
}
## aliases
alias meval { eval [join [args]]; complete }
# main alias
alias mp3 {
  switch -- [string tolower [left 2 [lindex [args] 0]]] {
    -h {
      echo "[bul] help            (req)   (opt)              (desc)"
      echo "[bul] \[[c2]play     [c1]\] mp3 \[path/wildcard\]            (none for random)"
      echo "[bul] \[[c2]setup    [c1]\] mp3 -sdpcv  \[dir/path\]         (setup  [c2]:[c1] dir [c2]:[c1] player [c2]:[c1] continuous [c2]:[c1] version check)"
      echo "[bul] \[[c2]message  [c1]\] mp3 -m      \[add/del/list\]     (restrict windows: add [c2]:[c1] delete [c2]:[c1] list [c2]:[c1] no parms toggles msg)"
      echo "[bul] \[[c2]format   [c1]\] mp3 -f      \[format chars\]     (no chars for help)"
      echo "[bul] \[[c2]list     [c1]\] mp3 -l\[shf\] \[wild/dir\]         (size [c2]:[c1] horizontal [c2]:[c1] full)"
      echo "[bul] \[[c2]update   [c1]\] mp3 -u                         (checks if there's a new version)"
      echo "[bul] playlist"
      echo "[bul] \[[c2]lists    [c1]\] pl -scif    \[file\]             (status [c2]:[c1] create new [c2]:[c1] load old [c2]:[c1] list)"
      echo "[bul] \[[c2]manage   [c1]\] pl -adl     \[file\]             (add mp3 ('current' adds current) [c2]:[c1] delete mp3 [c2]:[c1] list)"
      echo "[bul] \[[c2]play     [c1]\] pl -pngr    \[number\]           (previous [c2]:[c1] next [c2]:[c1] go to [c2]:[c1] random)"
      echo "[bul] \[[c2]toggle   [c1]\] pl -t\[os\]                      (status [c2]:[c1] shuffle)"
    }
    -s {
      echo "[bul] \[[c2]directory [c1]\] [get_cookie setup(dir)]"
      echo "[bul] \[[c2]player    [c1]\] [get_cookie setup(player)]"
      if {[get_cookie setup(msg)]} { set x on } else { set x off }
      echo "[bul] \[[c2]message   [c1]\] $x"
      if {[get_cookie setup(continuous)]} { set x on } else { set x off }
      echo "[bul] \[[c2]continuous[c1]\] $x"
      if {[get_cookie setup(playing)]} {
        echo "[bul] \[[c2]current   [c1]\] [file tail [get_cookie hist(last.played)]][c2]([c1][mp3len [get_cookie hist(last.played)]][c2]/[c1][minsec [get_cookie setup(playing)]] left[c2])"
      }
    }
    -d {
      if {[lindex [args] 1] == ""} {
        set tmp [prompt "mp3 directory?" "mp3 directory:" ""]
        regsub -all -- {\\} $tmp "/" tmp
        while {![file isdirectory $tmp]} {
          if {$tmp == ""} { echo "[bul] no changes made.."; complete; return }
          set tmp [prompt "invalid directory" "mp3 directory:" "[get_cookie setup(dir)]"]
        }
        if {[right 1 $tmp] != "/"} { append tmp / }
        set_cookie setup(dir) $tmp
        echo "[bul] directory set to \[[c2][get_cookie setup(dir)][c1]\]"
      } else {
        set tmp [join [lrange [args] 1 end]]
        regsub -all -- {\\} $tmp / tmp
        if {![file isdirectory $tmp]} {
          echo "[bul] invalid directory \[[c2][join [lrange [args] 1 end]][c1]\]"
        } else {
          if {[right 1 $tmp] != "/"} { append tmp / }
          set_cookie setup(dir) $tmp
          echo "[bul] directory set to \[[c2][get_cookie setup(dir)][c1]\]"
        }
      }
    }
    -p {
      if {[lindex [args] 1] == ""} {
        set tmp [string tolower [prompt "path to player?" "path to player:" ""]]
        regsub -all -- {\\} $tmp / tmp
        while {![file exists $tmp]} {
          if {$tmp == ""} { echo "[bul] no changes made.."; complete; return }
          set_cookie setup(player) [string tolower [prompt "invalid path" "path to player:" "[get_cookie setup(player)]"]]
        }
        if {[right 4 $tmp] != ".exe"} {
          echo "[bul] not an executable \[[c2]$tmp[c1]\]"
        } else {
          set_cookie setup(player) $tmp
          echo "[bul] player set to \[[c2][get_cookie setup(player)][c1]\]"
        }
      } else {
        set tmp [string tolower [join [lrange [args] 1 end]]]
        regsub -all -- {\\} $tmp / tmp
        if {![file exists $tmp]} {
          echo "[bul] invalid path \[[c2]$tmp[c1]\]"
        } elseif {[right 4 $tmp] != ".exe"} {
          echo "[bul] not an executable \[[c2]$tmp[c1]\]"
        } else {
          set_cookie setup(player) $tmp
          echo "[bul] player set to \[[c2][get_cookie setup(player)][c1]\]"
        }
      }
    }
    -m {
      if {[lindex [args] 1] == ""} {
        if {[get_cookie setup(msg)]} { set_cookie setup(msg) 0; echo "[bul] message now \[[c2]off[c1]\]"
        } else { set_cookie setup(msg) 1; echo "[bul] message now \[[c2]on[c1]\]" }
      } else {
        set cmd [string tolower [lindex [args] 1]]
        if {$cmd == "add"} {
          if {[lindex [args] 2] == ""} { echo "[bul] usage[c2]:[c1] /mp3 -m add <window>" } else {
            set win [lindex [args] 2]
            if {[lsearch [string tolower [get_cookie setup(msgwin)]] [string tolower $win]] > -1} { echo "[bul] window already added \[[c2]$win[c1]\]" } else {
              if {[string tolower $win] == "active"} { set win2 act } else { set win2 $win }
              set_cookie setup(msgwin) "[get_cookie setup(msgwin)] $win2"
              echo "[bul] added window [llength [get_cookie setup(msgwin)]] \[[c2]$win[c1]\]"
            }
          }
        } elseif {$cmd == "del"} {
          if {[lindex [args] 2] == ""} { echo "[bul] usage[c2]:[c1] /mp3 -m del <window>" } else {
            if {[lindex [args] 2] > 0 && [lindex [args] 2] < [expr [llength [get_cookie setup(msgwin)]] +1]} { set win [lindex [get_cookie setup(msgwin)] [expr [lindex [args] 2] -1]] } else { set win [lindex [args] 2] }
            if {$win == "act"} { set win active }
            if {[lsearch [string tolower [get_cookie setup(msgwin)]] [string tolower $win]] == -1} { echo "[bul] window not added \[[c2]$win[c1]\]" } else {
              if {$win == "active"} { set win act }
              if {[get_cookie setup(msgwin)] == "act"} { echo "[bul] must have at least one window (active)" } else {
                set num [lsearch [string tolower [get_cookie setup(msgwin)]] [string tolower $win]]
                set_cookie setup(msgwin) [lreplace [get_cookie setup(msgwin)] $num $num]
                if {$win == "act"} { set win active }
                echo "[bul] deleted window [expr $num +1] \[[c2]$win[c1]\]"
                if {[get_cookie setup(msgwin)] == ""} {
                  set_cookie setup(msgwin) act
                  echo "[bul] all windows deleted, adding \[[c2]active[c1]\] to list"
                }
              }
            }
          }
        } elseif {$cmd == "list"} {
          echo "[bul] restricted message windows"
          set i 0
          foreach a [get_cookie setup(msgwin)] {
            incr i 1
            if {$a == "act"} { set a active }
            echo "[bul] \[[c2][ralign $i 2][c1]\] $a"
          }
        } else { echo "[bul] invalid -m command \[[c2]$cmd[c1]\]" }
      }
    }
    -c {
      if {[get_cookie setup(continuous)]} { set_cookie setup(continuous) 0; echo "[bul] continuous play now \[[c2]off[c1]\]"
      } else { set_cookie setup(continuous) 1; echo "[bul] continuous play now \[[c2]on[c1]\]" }
    }
    -v {
      if {[get_cookie setup(autover)]} { set_cookie setup(autover) 0; echo "[bul] on-load version check now \[[c2]off[c1]\]"
      } else { set_cookie setup(autover) 1; echo "[bul] on-load version check now \[[c2]on[c1]\]" }
    }
    -f {
      if {[lindex [args] 1] == ""} {
        echo "[bul] \[[c2]format help[c1]\]"
        echo "[bul] this lets you format the msg that people see"
        echo "[bul] when the message is turned on.  all text besides"
        echo "[bul] the format chars is just left there."
        set x [get_cookie hist(last.played)]
        echo "[bul] current format: [mp3_format $x [file size $x]]"
        echo "[bul] %f\[df\]     [c2]:[c1] filename (d/directory f/full path)"
        echo "[bul] %s\[b/k/mb\] [c2]:[c1] size of filename (in bytes if none provided)"
        echo "[bul] %v         [c2]:[c1] mp3.tcl version"
        echo "[bul] %l\[s\]      [c2]:[c1] song length (s/seconds)"
        echo "[bul] usage: /mp3 -f <format chars/additional text>"
      } else {
        set_cookie setup(format) [join [lrange [args] 1 end]]
        echo "[bul] format now: [get_cookie setup(format)]"
      }
    }
    -l {
      if {[lindex [args] 1] != ""} {
        if {![file isdir [join [lrange [args] 1 end]]]} {
          if {[file isdir [get_cookie setup(dir)][join [lrange [args] 1 end]]] && ![string match *\[*\]* [join [lrange [args] 1 end]]]} {
            set rootdir [get_cookie setup(dir)][join [lrange [args] 1 end]]
            set wc 0
            set mtch *.mp3
          } else {
            set rootdir [get_cookie setup(dir)]
            set wc 1
            if {[right 4 [join [args]]] != ".mp3"} { set mtch [join [lrange [args] 1 end]].mp3 } else { set mtch [join [lrange [args] 1 end]] }
          }
        } else { set rootdir [join [lrange [args] 1 end]] }
      } else { set wc 0; set mtch *.mp3; set rootdir [get_cookie setup(dir)] }
      set full 0
      if {[string tolower [right 1 [lindex [args] 0]]] == "s"} {
        set tpl 0; set total 0; set k 0; set start [clock clicks]
        set temp ""; set temp1 ""; set temp2 ""; set temp3 "";
        foreach dir [glob -nocomplain $rootdir*/] {
          foreach file [glob -nocomplain $dir/$mtch] {
            lappend temp [str [expr 12 - [string length [file size [string tolower $file]]]] 0][file size [string tolower $file]][string tolower [file tail $file]]
          }
        }
        foreach file [glob -nocomplain $rootdir$mtch] {
          lappend temp [str [expr 12 - [string length [file size [string tolower $file]]]] 0][file size [string tolower $file]][string tolower [file tail $file]]
        }
        foreach file [lsort $temp] {
          incr total 1; incr k [string trimleft [lindex [split $file ] 0] 0]
          if {[get_cookie hist([string tolower [lindex [split $file ] 1]])] == ""} { set_cookie hist([string tolower [lindex [split $file ] 1]]) 0 }
          incr tpl [get_cookie hist([string tolower [lindex [split $file ] 1]])]
          echo "[bul] \[[c2][align [lindex [split $file ] 1] 59][c1]\] \[[c2][ralign [size [string trimleft [lindex [split $file ] 0] 0] mb] 6][c1]\] \[[c2][ralign [get_cookie hist([lindex [split $file ] 1])] 3][c1]\]"
        }
      } elseif {[string tolower [right 1 [lindex [args] 0]]] == "h"} {
        set total 0; set tpl 0; set i 0; set k 0; set mp3s ""; set temp ""; set start [clock clicks]
        foreach dir [glob -nocomplain $rootdir*/] {
          foreach file [glob -nocomplain $dir/$mtch] {
            incr k [file size $file]
            lappend temp [file tail $file]
          }
        }
        foreach file [glob -nocomplain $rootdir$mtch] {
          incr k [file size $file]
          lappend temp [file tail $file]
        }
        foreach file [lsort [string tolower $temp]] {
          if {[get_cookie hist([string tolower [file tail $file]])] == ""} { set_cookie hist([string tolower [file tail $file]]) 0 }
          incr total 1; incr i 1; incr tpl [get_cookie hist([string tolower $file])]
          if {$i == 3} {
            echo "[bul] [string trim $mp3s]"
            set i 1
            set mp3s "[c1]\[[c2][align $file 31][c1]\]\[[c2][ralign [get_cookie hist([string tolower $file])] 3][c1]\] "
          } else {
            append mp3s "[c1]\[[c2][align $file 31][c1]\]\[[c2][ralign [get_cookie hist([string tolower $file])] 3][c1]\] "
          }
        }
        echo "[bul] $mp3s"
      } elseif {[string tolower [right 1 [lindex [args] 0]]] == "f"} {
        set full 1; set total 0; set totalsec 0; set tpl 0; set k 0; set temp ""; set start [clock clicks]
        foreach dir [string tolower [glob -nocomplain $rootdir*/]] {
          foreach file [string tolower [glob -nocomplain $dir/$mtch]] {
            incr k [file size $file]
            lappend temp [string tolower $file]
          }
        }
        foreach file [string tolower [glob -nocomplain $rootdir$mtch]] {
          incr k [file size $file]
          lappend temp [string tolower $file]
        }
        foreach file [lsort $temp] {
          incr total 1
          if {[get_cookie hist([string tolower [file tail $file]])] == ""} { set_cookie hist([string tolower [file tail $file]]) 0 }
          incr tpl [get_cookie hist([string tolower [file tail $file]])]
          set len [mp3len $file]; incr totalsec [minsec $len]
          echo "[bul] \[[c2][align [file tail $file] 51][c1]\] \[[c2][ralign [size $file mb] 6][c1]\] \[[c2][ralign [get_cookie hist([string tolower [file tail $file]])] 3][c1]\] \[[c2][ralign $len 5][c1]\]"
        }
      } else {
        set total 0; set tpl 0; set k 0; set temp ""; set start [clock clicks]
        foreach dir [glob -nocomplain $rootdir*/] {
          foreach file [string tolower [glob -nocomplain $dir/$mtch]] {
            incr k [file size $file]
            lappend temp $file
          }
        }
        foreach file [glob -nocomplain $rootdir$mtch] {
          incr k [file size $file]
          lappend temp $file
        }
        foreach file [lsort [string tolower $temp]] {
          incr total 1
          if {[get_cookie hist([string tolower [file tail $file]])] == ""} { set_cookie hist([string tolower [file tail $file]]) 0 }
          incr tpl [get_cookie hist([string tolower [file tail $file]])]
          echo "[bul] \[[c2][align [file tail $file] 60][c1]\] \[[c2][ralign [size $file mb] 6][c1]\] \[[c2][ralign [get_cookie hist([string tolower [file tail $file]])] 3][c1]\]"
        }
      }
      if {![left 1 [size $k mb]]} { if {![left 1 [size $k k]]} { set size [size $k b] } else { set size [size $k k] } } else { set size [size $k mb] }
      if {!$total} {
        if {$wc} { set x \[[c2]$mtch[c1]\] } else { set x "" }
        echo "[bul] nothing to list $x"
      } else {
        if {$rootdir != [get_cookie setup(dir)]} { echo "[bul] \[[c2]directory  [c1]\] [string trimright $rootdir /]/" }
        if {$wc} { echo "[bul] \[[c2]wildcard   [c1]\] $mtch" }
        if {$full} { set full "[c2]:[c1] [duration $totalsec] " } else { set full "" }
        if {$total == 1} { set ext "" } else { set ext s }
        echo "[bul] \[[c2]totals     [c1]\] $total file$ext [c2]:[c1] $size $full[c2]:[c1] $tpl played"
        if {[get_cookie setup(playing)]} { set x "[minsec [get_cookie setup(playing)]] left" } else { set x "done" }
        echo "[bul] \[[c2]last played[c1]\] [file tail [get_cookie hist(last.played)]][c1]([c2][mp3len [get_cookie hist(last.played)]][c1]/[c2]$x[c1])"
        echo "[bul] \[[c2]exec time  [c1]\] [msformat [expr [clock clicks] - $start]]"
      }
    }
    -a {
      switch [random 1 2] {
        1 {
          # ansi by jer-pimp (the 3) and pawt (the rest)
          echo " "
          echo "               "
          echo "              "
          echo "              "
          echo "                  "
          echo "                     "
          echo "                       "
          echo "                              "
          echo "                     "
          echo "           "
          echo "                    "
          echo "                   "
          echo "                   "
          echo "                           "
          echo "               v2\[pawt\]"
          echo "               "
          echo " "
        }
        2 {
          # ansi by jer-pimp
          echo " "
          echo "                       "
          echo "                       "
          echo "                        "
          echo "                           " 
          echo "      "
          echo "     "
          echo "           "
          echo "         "
          echo "                 "
          echo "                    "
          echo "                         v2\[pawt\]"
          echo " "
        }
      }
    }
    -r {
      set i 0
      foreach dir [glob -nocomplain [get_cookie setup(dir)]*/] {
        foreach c [glob -nocomplain $dir/*.mp3] {
          incr i 1
          set_cookie hist([string tolower [file tail $c]]) 0
        }
      }
      foreach c [glob -nocomplain [get_cookie setup(dir)]*.mp3] {
        incr i 1
        set_cookie hist([string tolower [file tail $c]]) 0
      }
      echo "[bul] reset \[[c2]$i[c1]\] values"
    }
    -u { /mp3update }
    default {
      if {[left 1 [lindex [args] 0]] == "-"} {
        echo "[bul] invalid command \[[c2][join [args]][c1]\]"
      } elseif {![llength [findmp3 *]]} {
        echo "[bul] no mp3 files in \[[c2][get_cookie setup(dir)][c1]\]"
      } else {
        if {[join [args]] == ""} { set file [randmp3] } else {
          if {[string tolower [right 4 [join [args]]]] != ".mp3"} {
            if {![string match *:/* [join [args]]]} {
              set dir [get_cookie setup(dir)]
              set mtch [string tolower [file tail [join [args]]]]
            } else {
              set dir [file dirname [join [args]]]
              set mtch [string tolower [file tail [join [args]]]]
            }
            set x [findmp3 "$dir/$mtch*"]
            if {[llength $x] > 1} {
              echo "[bul] too many matches \[[c2]$mtch[c1]([c2][llength $x][c1])\]"
              set maxlen 0; set files ""
              foreach file $x { if {[string length [file tail $file]] > $maxlen} { set maxlen [string length [file tail $file]] }; lappend files [file tail $file] }
              foreach file [lsort $files] { echo "[bul] \[[c2][align [file tail $file] $maxlen][c1]\]" }
              complete; return
            } elseif {![llength $x]} {
              echo "[bul] no matches \[[c2]$mtch[c1]\]"; complete; return
            } else { set file $x }
          } else { set file [join [args]] }
        }
        set file [join $file]
        if {![file exists $file] || $file == ""} {
          if {![file exists "[get_cookie setup(dir)]$file"] || $file == ""} {
            echo "[bul] invalid file \[[c2][join [args]][c1]\]";complete;return
          } else { set file [get_cookie setup(dir)]$file }
        }
        exec [get_cookie setup(player)] $file &
        set_cookie hist(last.played) $file
        if {[minsec [mp3len $file]]} { set_cookie setup(playing) [expr [minsec [mp3len $file]] -5]
        } else { echo "[bul] warning: bitrate not found"; set_cookie setup(playing) 0 }
        if {[get_cookie hist([string tolower [file tail $file]])] == ""} { set_cookie hist([string tolower [file tail $file]]) 1
        } else { set_cookie hist([string tolower [file tail $file]]) [expr [get_cookie hist([string tolower [file tail $file]])] + 1] }
        if {$pl(on) && $pl(file) != ""} {
          if {[lsearch [allplay] $file] == -1} {
            echo "[bul] song not in playlist \[[c2][file tail $file][c1]([c2][mp3len $file][c1])\]"
          } else {
            set pl(current) [expr [lsearch [allplay] $file] +1]
            set_cookie pl(current) [expr [lsearch [allplay] $file] +1]
          }
        } elseif {[get_cookie setup(msg)]} {
          regsub -all {\&} $file {\&} file
          if {([window_type] == "channel" || [window_type] == "query" || [window_type] == "chat") && [connected]} {
            if {[lsearch [get_cookie setup(msgwin)] act] > -1 || ![llength [get_cookie setup(msgwin)]]} { say [mp3_format $file [file size $file]] }
            foreach win [get_cookie setup(msgwin)] {
              if {$win != "act"} {
                /msg $win [mp3_format $file [file size $file]]
              }
            }
          } else { echo "[bul] playing \[[c2][file tail $file][c1]([c2][mp3len $file][c1])\]" }
        } else { echo "[bul] playing \[[c2][file tail $file][c1]([c2][mp3len $file][c1])\]" }
      }
    }
  }
  complete
}
# playlist
alias pl {
  global pl
  if {[lindex [args] 0] == ""} { echo "[bul] no command given"; complete; return }
  switch -- [string tolower [string range [lindex [args] 0] 0 1]] {
    -h {
      echo "[bul] playlist help  (req)   (opt)               (desc)"
      echo "[bul] \[[c2]lists    [c1]\] pl -scif   \[file\]              (status [c2]:[c1] create new [c2]:[c1] load old [c2]:[c1] list)"
      echo "[bul] \[[c2]manage   [c1]\] pl -adl    \[file\]              (add mp3 ('current' adds current) [c2]:[c1] delete mp3 [c2]:[c1] list)"
      echo "[bul] \[[c2]play     [c1]\] pl -pngr   \[number\]            (previous [c2]:[c1] next [c2]:[c1] go to [c2]:[c1] random)"
      echo "[bul] \[[c2]toggle   [c1]\] pl -t\[os\]                      (status [c2]:[c1] shuffle)"
    }
    -s {
      echo "[bul] playlist"
      if {$pl(on)} { echo "[bul] \[[c2][align status 9][c1]\] on" } else { echo "[bul] \[[c2][align status 9][c1]\] off" }
      if {$pl(file) != ""} {
        if {[totplay $pl(file)] == 1} { set ext "" } else { set ext s }
        echo "[bul] \[[c2][align file 9][c1]\] [file tail $pl(file)] [c2]:[c1] [totplay $pl(file)] song$ext"
        if {[totplay $pl(file)] && $pl(current) && [file tail [curplay]] == [file tail [get_cookie hist(last.played)]]} {
          if {[get_cookie setup(playing)]} { set x "[minsec [get_cookie setup(playing)]] left" } else { set x "done" }
          echo "[bul] \[[c2][align current 9][c1]\] $pl(current) [c2]:[c1] [file tail [curplay]][c1]([c2][mp3len [curplay]][c1]/[c2]$x[c1])"
        }
        if {$pl(shuffle)} { echo "[bul] \[[c2][align shuffle 9][c1]\] on" } else { echo "[bul] \[[c2][align shuffle 9][c1]\] off" }
      }
    }
    -c {
      if {[lindex [args] 1] == ""} { echo "[bul] no name given" } else {
        if {[right 4 [lindex [args] 1]] != ".mpl"} { set file [lindex [args] 1].mpl } else { set file [lindex [args] 1] }
        if {[file exists $file]} {
          set x [string tolower [prompt "overwrite file?" "$file already exists. overwrite? \[yes/no\]" "yes"]]
          while {$x != "yes" && $x != "no"} { set x [string tolower [prompt "overwrite file?" "$file already exists. overwrite? \[yes/no\]" "yes"]] }
          if {$x} {
            set x [open $file w]; close $x
            echo "[bul] \[[c2][file tail $file][c1]\] created"
            echo "[bul] \[[c2]playlist editing[c1]\] mp3 -adl \[file\] (add/delete/list)"
          } else { echo "[bul] no playlist created.."; complete; return }
        } else {
          set x [open $file w]; close $x
          echo "[bul] \[[c2][file tail $file][c1]\] created"
          echo "[bul] \[[c2]playlist editing[c1]\] [event] -adl \[file\] (add/delete/list)"
        }
        set_cookie pl(file) $file
        set pl(file) $file
        set_cookie pl(current) 0
        set pl(current) 0
      }
    }
    -i {
      if {$pl(on)} { echo "[bul] turn playlist off first.."
      } elseif {[lindex [args] 1] == ""} { echo "[bul] /pl -i[c2]:14 no file given"
      } else {
        if {![file exists [lindex [args] 1]]} {
          if {[file exists [lindex [args] 1].mpl]} { set file [lindex [args] 1].mpl
          } elseif {[file exists [get_cookie setup(dir)][lindex [args] 1].mpl]} { set file [get_cookie setup(dir)][lindex [args] 1].mpl
          } elseif {![file exists [get_cookie setup(dir)][lindex [args] 1]]} {
            echo "[bul] invalid playlist file \[[c2][lindex [args] 1][c1]\]"; complete; return
          } else { set file [get_cookie setup(dir)][lindex [args] 1] }
        } else { set file [lindex [args] 1] }
        set_cookie pl(file) $file; set pl(file) $file
        echo "[bul] \[[c2][file tail $pl(file)][c1]\] loaded. total songs: \[[c2][totplay $pl(file)][c1]\]"
      }
    }
    -f {
      echo "[bul] playlists"; set i 0
      foreach c [glob -nocomplain [pwd]/*.mpl] { incr i 1; echo "[bul] \[[c2][ralign $i 3][c1]\] \[[c2][align [file tail $c] 22][c1]\] \[[c2][ralign [totplay $c] 3][c1]\]" }
      echo "[bul] loading[c2]:[c1] pl -i <filename.mpl>"
    }
    -a {
      if {$pl(file) == "" || ![file exists $pl(file)]} { echo "[bul] playlist file not found. load or create one.." } else {
        if {[join [lrange [args] 1 end]] == ""} { echo "[bul] /pl -a[c2]:14 no file given"; set file ""
        } elseif {[string tolower [join [lrange [args] 1 end]]] == "current"} {
          if {!$pl(current)} { echo "[bul] no song playing.." } else { set file [curplay] }
        } elseif {![file exists [join [lrange [args] 1 end]]]} {
          if {![file exists [get_cookie setup(dir)][join [lrange [args] 1 end]]]} { echo "[bul] invalid file \[[c2][join [lrange [args] 1 end]][c1]\]"; set file ""
          } else { set file [get_cookie setup(dir)][join [lrange [args] 1 end]] }
        } else { set file [join [lrange [args] 1 end]] }
        if {$file != ""} {
          set x [open $pl(file) a]; puts $x $file; close $x
          echo "[bul] entry \[[c2][totplay $pl(file)][c1]\] added: \[[c2][file tail $file][c1]\]"
        }
      }
    }
    -d {
      if {$pl(file) == "" || ![file exists $pl(file)]} { echo "[bul] playlist file not found. load or create one.." } else {
        if {[join [lrange [args] 1 end]] == ""} { echo "[bul] /pl -d[c2]:14 no file given" } else {
          if {[isnum [lindex [args] 1]] && ![file exists [join [lrange [args] 1 end]]]} {
            if {[songnum [lindex [args] 1]] == ""} { echo "[bul] invalid number \[[c2][lindex [args] 1][c1]\]" } else {
              set tmp [allplay]
              set file [songnum [lindex [args] 1]]
              set files [lreplace $tmp [expr [lindex [args] 1] -1] [expr [lindex [args] 1] -1]]
              set x [open $pl(file) w]; foreach a $files { puts $x $a }; close $x
              echo "[bul] removed song [lindex [args] 1] \[[c2][file tail $file][c1]\]"
            }
            complete; return
          } elseif {![file exists [join [lrange [args] 1 end]]]} {
            if {![file exists [get_cookie setup(dir)][join [lrange [args] 1 end]]]} { set file ""
            } else { set file [get_cookie setup(dir)][join [lrange [args] 1 end]] }
          } else { set file [join [lrange [args] 1 end]] }
          set tmp [allplay]
          if {[lsearch $tmp $file] > -1 || [lsearch $tmp [file tail $file]] > -1} {
            set i 0; set pltmp ""
            foreach c $tmp { if {$c != $file && $c != [file tail $file]} { lappend pltmp $c } else { incr i 1 } }
            if {$i == 1} { set x entry } else { set x entries }
            echo "[bul] deleted \[[c2]$i[c1]\] $x for \[[c2][file tail [join [lrange [args] 1 end]]][c1]\]"
            set x [open $pl(file) w]; foreach c $pltmp { puts $x $c }; close $x
          } else { echo "[bul] file not in playlist \[[c2][file tail [join [lrange [args] 1 end]]][c1]\]" }
        }
      }
    }
    -l {
      if {$pl(file) == ""} { echo "[bul] playlist file not found. load or create one.." } else {
        echo "[bul] files in playlist \[[c2][file tail $pl(file)][c1]([c2][totplay $pl(file)][c1])\]"
        set tot 0; set totsec 0
        foreach tmp [allplay] { set len [mp3len $tmp]; incr tot 1; incr totsec [minsec $len]; echo "[bul] \[[c2][ralign $tot 3][c1]\] \[[c2][align [file tail $tmp] 60][c1]\] \[[c2][ralign $len 5][c1]\]" }
        echo "[bul] total length[c2]:[c1] [duration $totsec]"
      }
    }
    -p {
      if {!$pl(on)} { echo "[bul] playlist not on"
      } elseif {$pl(file) == ""} { echo "[bul] no playlist file. load or create one.."
      } elseif {!$pl(current)} { echo "[bul] playlist not started"
      } else {
        incr pl(current) -1
        if {!$pl(current)} { set pl(current) [totplay $pl(file)] }
        set x [open $pl(file)]; set i 0
        while {[gets $x file] > -1} { incr i 1; if {$i == $pl(current)} { break } }
        close $x
        echo "[bul] skipping to previous file \[[c2][file tail $file][c1]([c2][mp3len $file][c1])\]"
        set_cookie pl(current) $pl(current)
        /mp3 $file
      }
    }
    -n {
      if {!$pl(on)} { echo "[bul] playlist not on"
      } elseif {$pl(file) == ""} { echo "[bul] no playlist file. load or create one.."
      } elseif {!$pl(current)} { echo "[bul] playlist not started"
      } else {
        incr pl(current) 1
        if {$pl(current) > [totplay $pl(file)]} { set pl(current) [expr $pl(current) % [totplay $pl(file)]] }
        set x [open $pl(file)]; set i 0
        while {[gets $x file] > -1} { incr i 1; if {$i == $pl(current)} { break } }
        echo "[bul] skipping to next file \[[c2][file tail $file][c1]([c2][mp3len $file][c1])\]"
        close $x
        set_cookie pl(current) $pl(current)
        /mp3 $file
      }
    }
    -g {
      if {!$pl(on)} { echo "[bul] playlist not on"
      } elseif {$pl(file) == ""} { echo "[bul] no playlist file. load or create one.."
      } elseif {!$pl(current)} { echo "[bul] playlist not started"
      } elseif {![isnum [lindex [args] 1]] || [lindex [args] 1] == ""} { echo "[bul] /pl -g[c2]:[c1] need a number"
      } else {
        if {[lindex [args] 1] > [totplay $pl(file)] || [lindex [args] 1] < 1} { echo "[bul] invalid song number \[[c2][lindex [args] 1][c1]\]" } else {
          set pl(current) [lindex [args] 1]; set_cookie pl(current) [lindex [args] 1]
          echo "[bul] skipping to song [lindex [args] 1] \[[c2][file tail [lindex [allplay] [expr [lindex [args] 1] -1]]][c1]([c2][mp3len [lindex [allplay] [expr [lindex [args] 1] -1]]][c1])\]"
          /mp3 [lindex [allplay] [expr [lindex [args] 1] -1]]
        }
      }
    }
    -r {
      if {!$pl(on)} { echo "[bul] playlist not on"
      } elseif {$pl(file) == ""} { echo "[bul] no playlist file. load or create one.."
      } elseif {!$pl(current)} { echo "[bul] playlist not started"
      } else {
        set num [random 0 [expr [totplay $pl(file)] -1]]
        set file [songnum $num]
        echo "[bul] skipping to random file \[[c2]$num[c1]\] \[[c2][file tail $file][c1]([c2][mp3len $file][c1])\]"
        /mp3 $file
      }
    }
    -t {
      if {[string range [lindex [args] 0] 2 end] == "o"} {
        if {$pl(on)} {
          set_cookie pl(on) 0; set pl(on) 0
          if {$pl(current) && ![get_cookie setup(playing)]} { set pl(current) 0; set_cookie pl(current) 0 }
          echo "[bul] playlist now \[[c2]off[c1]\]"
        } else {
          set_cookie pl(on) 1; set pl(on) 1; echo "[bul] playlist now \[[c2]on[c1]\]"
          if {$pl(file) == ""} { echo "[bul] playlist file not found. load or create one.." } else {
            if {![totplay $pl(file)]} { echo "[bul] no songs to play. add some to the list.." } else {
              if {!$pl(current) && ![get_cookie setup(playing)]} {
                set x [open $pl(file)]
                gets $x y
                close $x
                echo "[bul] playlist started"
                echo "[bul] now playing \[[c2][file tail $y][c1]\]"
                set_cookie pl(current) 1; set pl(current) 1
                /mp3 $y
              }
            }
          }
        }
      } elseif {[string range [lindex [args] 0] 2 end] == "s"} {
        if {$pl(shuffle)} { set_cookie pl(shuffle) 0; set pl(shuffle) 0; echo "[bul] shuffle now \[[c2]off[c1]\]"
        } else { set_cookie pl(shuffle) 1; set pl(shuffle) 1; echo "[bul] shuffle now \[[c2]on[c1]\]" }
        set_cookie pl(shuffle) $pl(shuffle)
      } else { echo "[bul] toggles[c2]:"; echo "[bul] -to [c2]:[c1] turn playlist off/on"; echo "[bul] -ts [c2]:[c1] turn shuffle on/off" }
    }
    default { echo "[bul] invalid command \[[c2][string tolower [lindex [args] 0]][c1]\]" }
  }
  complete
}
# updater
set sock ""
set latest 0
alias mp3update {
  if {[lindex [args] 0] == "-s"} { set silent 1 } else { set silent 0 }
  if {!$silent} { echo "[bul] checking for newer version of mp3.tcl" }
  global sock latest
  if {[catch {set sock [socket -async 209.160.120.3 80]} text]} {
    if {!$silent} { echo "[bul] error opening socket" }
  } else {
    fconfigure $sock -blocking no
    puts $sock "GET /~fire/mp3ver.txt"
    flush $sock
    fileevent $sock readable {
      global sock latest
      while {[gets $sock line] > -1} {
        if {$line != "mp3ver"} {
          if {[string index $line 0] == "h"} { set mp3url $line
          } elseif {$line > [get_cookie setup(vernum)]} { set latest 0
          } elseif {$line < [get_cookie setup(vernum)] || $line == [get_cookie setup(vernum)]} { set latest 1 }
        }
      }
      close $sock
      if {$latest} { if {!$silent} { echo "[bul] current version of mp3.tcl is the latest.." } } else {
        echo "[bul] current version of mp3.tcl is old, download the latest version at[c2]:[c1]"
        echo "[bul] $mp3url"
      }
    }
  }
  complete
}
## hotkeys
hotkey control+m { /mp3; complete }
hotkey control+alt+m {
  set tmp [prompt "filename?" "filename:" ""]
  if {$tmp != ""} { /mp3 $tmp }
  complete
}
## events
on timer {
  if {[get_cookie setup(playing)] && [active]} {
    set_cookie setup(playing) [expr [get_cookie setup(playing)] - 1]
    if {$pl(on) && $pl(file) != "" && ![get_cookie setup(playing)]} {
      incr pl(current) 1
      if {$pl(current) > [totplay $pl(file)]} { set pl(current) [expr $pl(current) % [totplay $pl(file)]] }
      if {$pl(shuffle)} { set pl(current) [random 0 [expr [llength [allplay]] - 1]]; set file [lindex [allplay] $pl(current)]
      } else { set file [lindex [allplay] [expr $pl(current) - 1]] }
      set file [join $file]
      echo "[bul] \[[c2][file tail [get_cookie hist(last.played)]][c1]([c2][mp3len [get_cookie hist(last.played)]][c1])\] is done"
      echo "[bul] playing \[[c2][file tail $file][c1]([c2][mp3len $file][c1])\] next.."
      set_cookie pl(current) $pl(current)
      /mp3 $file
    } elseif {![get_cookie setup(playing)] && [get_cookie setup(continuous)]} {
      set_cookie setup(cont.file) [randmp3]
      while {[mp3len [get_cookie setup(cont.file)]] == "0:00" || [file tail [get_cookie mp3(cont.file)]] == [file tail [get_cookie hist(last.played)]]} {
        set_cookie setup(cont.file) [randmp3]
      }
      echo "[bul] \[[c2][file tail [get_cookie hist(last.played)]][c1]([c2][mp3len [get_cookie hist(last.played)]][c1])\] is done"
      /mp3 [get_cookie setup(cont.file)]
    }
  }
}

on load {
  set start [clock clicks]
  set_cookie setup(vernum) 4
  set_cookie setup(ver) mp3.tcl(2)
  if {![get_cookie setup(playing) 0]} { set_cookie setup(playing) 0 }
  if {![string length [get_cookie setup(dir)]]} {
    set_cookie setup(dir) [prompt "mp3 directory?" "mp3 directory:" ""]
    while {![file isdirectory [get_cookie setup(dir)]]} { set_cookie setup(dir) [prompt "invalid directory" "mp3 directory:" "[get_cookie setup(dir)]"] }
  }
  if {![string length [get_cookie setup(player)]]} {
    set_cookie setup(player) [prompt "path to player?" "path to player:" ""]
    while {![file exists [get_cookie setup(player)]]} { set_cookie setup(player) [prompt "invalid path" "path to player:" "[get_cookie setup(player)]"] }
  }
  if {![string length [get_cookie setup(msg)]]} { set_cookie setup(msg) 0 }
  if {![string length [get_cookie setup(continuous)]]} { set_cookie setup(continuous) 0 }
  if {![string length [get_cookie setup(format)]]} { set_cookie setup(format) "\[%f/%sk\] %v" }
  if {![string length [get_cookie pl(file)]]} { set_cookie pl(file) "" }
  if {![string length [get_cookie pl(on)]]} { set_cookie pl(on) 0 }
  if {![string length [get_cookie pl(current)]]} { set_cookie pl(current) 0 }
  if {![string length [get_cookie pl(shuffle)]]} { set_cookie pl(shuffle) 0 }
  if {![string length [get_cookie setup(msgwin)]]} { set_cookie setup(msgwin) act }
  if {![string length [get_cookie setup(autover)]]} { set_cookie setup(autover) 0 }
  set x [get_cookie setup(dir)]; regsub -all {\\} $x "/" x; set_cookie setup(dir) $x
  set pl(file) [get_cookie pl(file)]
  set pl(on) [get_cookie pl(on)]
  set pl(current) [get_cookie pl(current)]
  set pl(shuffle) [get_cookie pl(shuffle)]
  set pl(songs) 0
  if {![string length [get_cookie setup(loaded)]]} {
    /mp3 -a
    echo "[bul] loaded [get_cookie setup(ver)] in \[[c2][msformat [expr [clock clicks] - $start]][c1]\]"
    echo "[bul] for help, type /mp3 -h"
    echo "[bul] read mp3.txt for extended help and version info"
    set_cookie setup(loaded) 1
  } else { echo "[bul] loaded [get_cookie setup(ver)] in \[[c2][msformat [expr [clock clicks] - $start]][c1]\]" }
  if {[get_cookie setup(autover)]} { /mp3update -s }
  complete
}
